;; 
;;  This DOES NOT WORK (2007-04-25) but should. Returning the assembly from the event-handler to the event-trigger
;;  causes the entire application to crash.
;; 
;;
;; Alternative method of loading an assembly that doesn't lock the assembly file:
;; C#
;; byte[] asm = File.ReadAllBytes(asmPath);
;; return Assembly.Load(asm);

(in-package :rdnzl-user)

(defparameter *additional-assembly-directories* nil)
(pushnew "C:/temp/" *additional-assembly-directories*)

(defun assembly-resolver (app-domain resolve-event-args)
  (declare (ignore app-domain))
  (let ((assembly-name (property resolve-event-args "Name")))
    (loop 
	with filename = (make-pathname :name assembly-name :type "dll")
	for dir in *additional-assembly-directories*
	for dirpath = (if (pathnamep dir) dir (parse-namestring dir))
	for path = (merge-pathnames dirpath filename)
	when (probe-file path)
	do (format *error-output* "Found, using LoadFile to load assembly.~%") 
	   (let* ((evidence (property (invoke "System.Reflection.Assembly" "GetExecutingAssembly") "Evidence"))
		  (assembly  (invoke "System.Reflection.Assembly" "LoadFile" (namestring path) evidence)))
	     
	     (format *error-output* "Assembly is ~a~%" assembly)
	     ;; This crashes the entire application, but not before the assembly has been loaded.
	     (return-from assembly-resolver assembly))
	finally (return (make-null-object "System.Reflection.Assembly")))))
	

(defun install-assembly-resolve-handler (&optional (handler #'assembly-resolver))
  (let ((my-domain (property "System.AppDomain" "CurrentDomain"))
	(assembly-resolve-delegate (new "System.ResolveEventHandler" handler)))
    (invoke my-domain "add_AssemblyResolve" assembly-resolve-delegate)))




